Assignee: Go MAEDA % Done: 0%

Category: Custom fields Estimated time: 0.00 hour

Target version: 6.1.0   

Resolution: Fixed   

Description

The attached patch adds a new custom field format "Progress bar", which behaves like the existing "Done Ratio" Issue field. Patch

was extracted from Planio

Related issues:

Related to Redmine - Feature #9629: New custom field format 'progress bar' (l... New 2011-11-22

Associated revisions

Revision 23560 - 2025-03-26 11:33 - Go MAEDA

"Progress bar" custom field format (#42335).

Patch by Jens Krämer (user:jkraemer).

Revision 23561 - 2025-03-26 11:37 - Go MAEDA

Update locales (#42335).

Revision 23686 - 2025-04-19 10:46 - Go MAEDA

Adds interval ratio setting to progressbar custom field (#42335).

Patch by Marius BĂLTEANU (user:marius.balteanu) and Go MAEDA (user:maeda).

Revision 23688 - 2025-04-20 05:33 - Go MAEDA

Add missing _filters.html.erb view file that was not included in r23686 (#42335).

History

#1 - 2025-03-01 08:36 - Go MAEDA

- File clipboard-202503011635-39vmc.png added

- File clipboard-202503011635-l2v4w.png added

- Target version set to Candidate for next major release

Screenshots:

 clipboard-202503011635-l2v4w.png 

 clipboard-202503011635-39vmc.png 

#2 - 2025-03-02 08:52 - Jens Krämer

- File 0001-progress-bar-field-format-1168755.patch added

Thank you for creating the screenshots. Here is an updated patch with references to Planio removed.

#3 - 2025-03-03 00:23 - Mischa The Evil

- Related to Feature #9629: New custom field format 'progress bar' (like the %-done field). added

#4 - 2025-03-03 04:33 - Mischa The Evil

Just my two cents on this: if a feature like this is deemed eligible for core integration, I think it might be good to preemptively consider, explicitly,

whether or not it might be better to not reuse the global issue_done_ratio_interval setting, but instead implement it independently as a custom field
attribute so that each progress bar custom field can have its own dedicated done_ratio_interval value.

#5 - 2025-03-24 10:33 - Go MAEDA

- Target version changed from Candidate for next major release to 6.1.0

Setting the target version to 6.1.0.

#6 - 2025-03-26 11:37 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch in r23560. Thank you for submitting it.

#7 - 2025-03-26 11:37 - Go MAEDA

- Tracker changed from Patch to Feature

- Resolution set to Fixed

#8 - 2025-03-27 23:38 - Marius BĂLTEANU

- File 0001-Adds-interval-ratio-setting-to-progressbar-custom-fi.patch added

- Status changed from Closed to Reopened

Mischa The Evil wrote in #note-4:

Just my two cents on this: if a feature like this is deemed eligible for core integration, I think it might be good to preemptively consider, explicitly,

whether or not it might be better to not reuse the global issue_done_ratio_interval setting, but instead implement it independently as a custom

field attribute so that each progress bar custom field can have its own dedicated done_ratio_interval value.

 Mischa, I agree with you, the custom field should have its own setting to control the ratio interval. The attached patch implements this. If we really

want to have a dependency on Issue Done Ratio Interval, we can set the default value of this new attribute to the issue_done_ratio_interval or add a

special value that inherit the value of issue_done_ratio_interval.

I'm reopening this to discuss the improvement.

#9 - 2025-03-28 03:53 - Jens Krämer

The first iteration of this which I had implemented at Planio actually had this setting on the custom field in place. We dropped it in the end to keep it

simple and because we considered that someone wishing to have 5% intervals would likely want to have that level of precision everywhere.

But it certainly is cleaner to have the setting on the custom field, since these are not bound to issues only, but could be used anywhere, and then it is

actually confusing when an issue tracking setting influences a progress bar field on a document, for example. So, +1 from me.

#10 - 2025-04-02 11:50 - Go MAEDA

Marius BĂLTEANU wrote in #note-8:

If we really want to have a dependency on Issue Done Ratio Interval, we can set the default value of this new attribute to the

issue_done_ratio_interval or add a special value that inherit the value of issue_done_ratio_interval.

 I noticed that the default value of the new "Ratio interval" for custom fields introduced in the additional patch is set to 5%, whereas the existing "Done

Ratio options interval" has a default of 10%. This difference might be confusing. For consistency, it may be better to either set the default to 10% or

inherit the value from issue_done_ratio_interval.

#11 - 2025-04-02 13:13 - Marius BĂLTEANU

Go MAEDA wrote in #note-10:

Marius BĂLTEANU wrote in #note-8:

[..]

 I noticed that the default value of the new "Ratio interval" for custom fields introduced in the additional patch is set to 5%, whereas the existing

"Done Ratio options interval" has a default of 10%. This difference might be confusing. For consistency, it may be better to either set the default

to 10% or inherit the value from issue_done_ratio_interval.

2025-05-01 2/4

https://www.redmine.org/projects/redmine/repository/svn/revisions/23560


 I agree with you regarding 10% as default. Also, I think we should persist the value in the database for each custom field saved.

#12 - 2025-04-03 22:18 - Marius BĂLTEANU

- File 0001-Adds-interval-ratio-setting-to-progressbar-custom-fi.patch added

I've updated the patch to persist the interval ratio for all custom fields of type progress bar. The default value is inherit from

Setting.issue_done_ratio_interval.to_i.

Jens Krämer, please let me know if your initial solution had a better way to set the default value for ratio interval.

#13 - 2025-04-16 12:04 - Go MAEDA

Marius BĂLTEANU wrote in #note-12:

I've updated the patch to persist the interval ratio for all custom fields of type progress bar. The default value is inherit from

Setting.issue_done_ratio_interval.to_i.

 Thank you for posting the patch.

I found that the value of Setting.issue_done_ratio_interval will not be reflected on /custom_fields/*/edit pages unless the Redmine application is

restarted. This is because the constant DEFAULT_RATIO_INTERVAL is initialized only when the application starts.

To fix the issue, I suggest changing the patch as follows:

diff --git a/app/views/custom_fields/formats/_progressbar.html.erb b/app/views/custom_fields/formats/_progress

bar.html.erb

index 9077aebaf..02613e5e5 100644

--- a/app/views/custom_fields/formats/_progressbar.html.erb

+++ b/app/views/custom_fields/formats/_progressbar.html.erb

@@ -1,3 +1,3 @@

 <p>

-  <%= f.select :ratio_interval, [5, 10].collect {|i| ["#{i} %", i]}, selected: Redmine::FieldFormat::Progress

barFormat::DEFAULT_RATIO_INTERVAL, required: true %>

-</p>

\ No newline at end of file

+  <%= f.select :ratio_interval, [5, 10].collect {|i| ["#{i} %", i]}, selected: Redmine::FieldFormat::Progress

barFormat.default_ratio_interval, required: true %>

+</p>

diff --git a/lib/redmine/field_format.rb b/lib/redmine/field_format.rb

index da46a4d5c..2a76f2c46 100644

--- a/lib/redmine/field_format.rb

+++ b/lib/redmine/field_format.rb

@@ -1092,7 +1092,9 @@ module Redmine

       # Take the default value from Setting.issue_done_ratio_interval.to_i

       # in order to have a consistent behaviour for default ratio interval.

-      DEFAULT_RATIO_INTERVAL = Setting.issue_done_ratio_interval.to_i

+      def self.default_ratio_interval

+        Setting.issue_done_ratio_interval.to_i

+      end

       def label

         "label_progressbar" 

@@ -1121,7 +1123,7 @@ module Redmine

         super

         if custom_field.ratio_interval.blank?

-          custom_field.ratio_interval = DEFAULT_RATIO_INTERVAL

+          custom_field.ratio_interval = self.class.default_ratio_interval

         end

       end

diff --git a/test/functional/issues_controller_test.rb b/test/functional/issues_controller_test.rb

index 005864d4c..9b6feac5f 100644

--- a/test/functional/issues_controller_test.rb

+++ b/test/functional/issues_controller_test.rb

@@ -5987,7 +5987,6 @@ class IssuesControllerTest < Redmine::ControllerTest

     get(:edit, :params => {:id => 1})

     assert_response :success

-    puts response.body

     assert_select "select[id=?]", "issue_custom_field_values_#{cf.id}", 1

   end
#14 - 2025-04-19 10:47 - Go MAEDA

- Status changed from Reopened to Closed

Committed the additional patch submitted in #note-12 with some changes in r23686.

#15 - 2025-04-19 13:57 - Marius BĂLTEANU

Go MAEDA wrote in #note-13:

Marius BĂLTEANU wrote in #note-12:

I've updated the patch to persist the interval ratio for all custom fields of type progress bar. The default value is inherit from

Setting.issue_done_ratio_interval.to_i.

 Thank you for posting the patch.

I found that the value of Setting.issue_done_ratio_interval will not be reflected on /custom_fields/*/edit pages unless the Redmine application is

restarted. This is because the constant DEFAULT_RATIO_INTERVAL is initialized only when the application starts.

To fix the issue, I suggest changing the patch as follows:

[...]

 Thanks for catching and fixing those errors!

Files

0001-progress-bar-field-format-1168755.patch 9.08 KB 2025-02-28 Jens Krämer

clipboard-202503011635-39vmc.png 96.5 KB 2025-03-01 Go MAEDA

clipboard-202503011635-l2v4w.png 11.3 KB 2025-03-01 Go MAEDA

0001-progress-bar-field-format-1168755.patch 6.5 KB 2025-03-02 Jens Krämer

0001-Adds-interval-ratio-setting-to-progressbar-custom-fi.patch 6.53 KB 2025-03-27 Marius BĂLTEANU

0001-Adds-interval-ratio-setting-to-progressbar-custom-fi.patch 6.98 KB 2025-04-03 Marius BĂLTEANU
